// forward from cocoon to call this
window.setGif = function (name) {
    var fillScreen = document.getElementById("gif");
    fillScreen.style["background-image"] = "url('" + name + ".gif')";
    fillScreen.addEventListener('click', onOpen, false);

    window.setGameLogo(name);
};

window.setVideo = function (name) {
    var container = document.getElementById("video");
    var video = document.getElementById("videoElement");
    var source = document.createElement("source");
    // video.setAttribute("muted", "true");
    // video.setAttribute("loop", "true");
    // video.setAttribute("autoplay", "true");
    // video.autoplay = true;
    // video.muted = true;
    // video.setAttribute("playsinline", "true");
    // video.setAttribute("webkit-playsinline", "true");
    source.setAttribute("type", "video/mp4");
    source.setAttribute("src", "./" + name + ".mp4");
    // video.setAttribute("controls", "controls");

    video.appendChild(source);
    container.appendChild(video);
    video.load();

    window.enableInlineVideo(video);
};

window.setImageUrl = function (url) {
    var fillScreen = document.getElementById("gif");
    fillScreen.style["background-image"] = "url('" + url + "')";
    fillScreen.addEventListener('click', onOpen, false);
};
window.setVideoUrl = function (urls) {
    var container = document.getElementById("video");
    var video = document.getElementById("videoElement");
    var i, l;
    var loopUrls = function (url) {
        // append multiple sources
        var source = document.createElement("source");
        source.setAttribute("type", "video/mp4");
        source.setAttribute("src", url);

        video.appendChild(source);
    };

    // clean all sources
    // var sources = document.getElementsByTagName('source');
    // for (i = 0, l = sources.length; i < l; ++i) {
    //     removeElement(sources[i]);
    // }
    if (video) {
        removeElement(video);
    }
    video = document.createElement('video');
    video.id = "videoElement";
    video.setAttribute("muted", "true");
    video.setAttribute("loop", "true");
    video.setAttribute("autoplay", "true");
    video.setAttribute("playsinline", "true");
    video.setAttribute("webkit-playsinline", "true");
    video.autoplay = true;
    video.muted = true;


    // argument must be an array
    if (!Array.isArray(urls)) {
        urls = [urls];
    }

    // attach sources
    for (i = 0; i < urls.length; ++i) {
        loopUrls(urls[i]);
    }

    container.appendChild(video);
    video.load();

    window.enableInlineVideo(video);
};

var escapeHtml = function (text) {
    var map = {
        '&': '&amp;',
        '<': '&lt;',
        '>': '&gt;',
        '"': '&quot;',
        "'": '&#039;'
    };

    return text.replace(/[&<>"']/g, function (m) {
        return map[m];
    });
};
window.setTitle = function (name) {
    var title = document.getElementById("title");
    title.innerHTML = escapeHtml(name);
};
//add game logo in right top corner
window.setGameLogo = function (name) {
    var gameLogo = document.getElementById("gamelogo");
    if (gameLogo) {
        gameLogo.src = "./" + name + ".png";
    }
};

// quick fix for multiple clicks:
var hasClicked = false;

// click on the buttons
var container = document.getElementById("container");
var playbutton = document.getElementById("playbutton");
var downloadbutton = document.getElementById("downloadbutton");
var opensymbol = document.getElementById("opensymbol");
var closesymbol = document.getElementById("closesymbol");
var onOpen = function (evt) {
    evt.stopPropagation();
    if (hasClicked) {
        return;
    }

    window.Cocoon.App.forward('window.openCrossPromo();');

    hasClicked = true;
    window.setTimeout(function () {
        hasClicked = false;
    }, 500);
};
var close = function (evt) {
    evt.stopPropagation();
    window.Cocoon.App.forward('window.closeTheWebview();');

    // Cocoon.WebView.hide();
};
var localize = function () {
    var translations = {
        en: {
            "text": "Play"
        },
        zh: {
            "text": "进入游戏"
        },
        zt: {
            "text": "進入遊戲"
        },
        pt: {
            "text": "Jogar",
            "font-size": "20px"
        },
        de: {
            "text": "Spielen",
            "font-size": "20px"
        },
        es: {
            "text": "Jugar",
            "font-size": "20px"
        },
        fr: {
            "text": "Jouer",
            "font-size": "20px"
        },
        it: {
            "text": "Gioca",
            "font-size": "20px"
        },
        ja: {
            "text": "プレイ",
            "font-size": "20px"
        },
        ko: {
            "text": "플레이",
            "font-size": "20px"
        },
        ru: {
            "text": "Играть",
            "font-size": "18px"
        }
    };
    var language = window.navigator.userLanguage || window.navigator.language;
    var code;
    var languageCode = 'en';

    if (language && language.substr) {
        code = language.substr(0, 2).toLowerCase();
        if (
            code === 'zh' ||
            code === 'pt' ||
            code === 'de' ||
            code === 'es' ||
            code === 'fr' ||
            code === 'it' ||
            code === 'ja' ||
            code === 'ko' ||
            code === 'ru'
        ) {
            languageCode = code;
        } else {
            languageCode = 'en';
        }
    }
    // special cases for chinese tradition (zh-TW) and HK (zh-HK):
    // ZT / ZHT, ZHK ?
    if (language.toLowerCase() === 'zh-tw' || language.toLowerCase().indexOf('zh-hant') >= 0) {
        languageCode = 'zt';
    } else if (language.toLowerCase() === 'zh-hk') {
        languageCode = 'zt';
    }

    // if (playbutton && translations[languageCode]["font-size"]) {
    //     playbutton.style['font-size'] = translations[languageCode]["font-size"];
    //     playbutton.style['line-height'] = '48px';
    //     playbutton.style['min-height'] = '48px';
    // }

    if (playbutton)
        playbutton.innerHTML = translations[languageCode].text;
};
var removeElement = function (element) {
    element.parentNode.removeChild(element);
};

container.addEventListener('click', onOpen, true);
if (playbutton)
    playbutton.addEventListener('click', onOpen, false);
if (downloadbutton)
    downloadbutton.addEventListener('click', onOpen, false);
if (opensymbol)
    opensymbol.addEventListener('click', onOpen, false);
if (closesymbol)
    closesymbol.addEventListener('click', close, false);

localize();

// setVideoUrl('./triggerheroes.mp4');
// setTitle('Trigger Heroes');
